/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime.js';
import type { CreateApplicationRequest, CreateApplicationResponse, GetApplicationResponse, GetApplicationsResponse, SuccessResponse, UpdateApplicationRequest } from '../models/index.js';
export interface CreateApplicationOperationRequest {
    createApplicationRequest?: CreateApplicationRequest;
}
export interface DeleteApplicationRequest {
    applicationId: string;
}
export interface GetApplicationRequest {
    applicationId: string;
}
export interface GetApplicationsRequest {
    sort?: GetApplicationsSortEnum;
    pageSize?: number | null;
    nextToken?: string | null;
}
export interface UpdateApplicationOperationRequest {
    applicationId: string;
    updateApplicationRequest?: UpdateApplicationRequest;
}
/**
 *
 */
export declare class ApplicationsApi extends runtime.BaseAPI {
    /**
     * Create an application.
     * Create Application
     */
    createApplicationRaw(requestParameters: CreateApplicationOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<CreateApplicationResponse>>;
    /**
     * Create an application.
     * Create Application
     */
    createApplication(requestParameters?: CreateApplicationOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<CreateApplicationResponse>;
    /**
     * Delete application.
     * Delete Application
     */
    deleteApplicationRaw(requestParameters: DeleteApplicationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<SuccessResponse>>;
    /**
     * Delete application.
     * Delete Application
     */
    deleteApplication(requestParameters: DeleteApplicationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<SuccessResponse>;
    /**
     * Gets an application given the application\'s id.
     * Get Application
     */
    getApplicationRaw(requestParameters: GetApplicationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<GetApplicationResponse>>;
    /**
     * Gets an application given the application\'s id.
     * Get Application
     */
    getApplication(requestParameters: GetApplicationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<GetApplicationResponse>;
    /**
     * Get a list of applications.
     * List Applications
     */
    getApplicationsRaw(requestParameters: GetApplicationsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<GetApplicationsResponse>>;
    /**
     * Get a list of applications.
     * List Applications
     */
    getApplications(requestParameters?: GetApplicationsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<GetApplicationsResponse>;
    /**
     * Update an application.
     * Update Application
     */
    updateApplicationRaw(requestParameters: UpdateApplicationOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<void>>;
    /**
     * Update an application.
     * Update Application
     */
    updateApplication(requestParameters: UpdateApplicationOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<void>;
}
/**
 * @export
 */
export declare const GetApplicationsSortEnum: {
    readonly Asc: "name_asc";
    readonly Desc: "name_desc";
};
export type GetApplicationsSortEnum = typeof GetApplicationsSortEnum[keyof typeof GetApplicationsSortEnum];
