/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime.js';
import type { TokenIntrospect, UserProfile, UserProfileV2 } from '../models/index.js';
export interface TokenIntrospectionRequest {
    token?: string;
    tokenType?: string;
}
export interface TokenRevocationRequest {
    token?: string;
    clientId?: string;
    clientSecret?: string;
}
/**
 *
 */
export declare class OAuthApi extends runtime.BaseAPI {
    /**
     * Contains the id, names and email of the currently logged in user.
     * Get User Profile
     */
    getUserRaw(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<UserProfile>>;
    /**
     * Contains the id, names and email of the currently logged in user.
     * Get User Profile
     */
    getUser(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<UserProfile>;
    /**
     * Contains the id, names, profile picture URL and email of the currently logged in user.
     * Returns the details of the currently logged in user
     */
    getUserProfileV2Raw(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<UserProfileV2>>;
    /**
     * Contains the id, names, profile picture URL and email of the currently logged in user.
     * Returns the details of the currently logged in user
     */
    getUserProfileV2(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<UserProfileV2>;
    /**
     * Retrieve information about the provided token.
     * Get token details
     */
    tokenIntrospectionRaw(requestParameters: TokenIntrospectionRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<TokenIntrospect>>;
    /**
     * Retrieve information about the provided token.
     * Get token details
     */
    tokenIntrospection(requestParameters?: TokenIntrospectionRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<TokenIntrospect>;
    /**
     * Revoke a previously issued token.
     * Revoke token
     */
    tokenRevocationRaw(requestParameters: TokenRevocationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<void>>;
    /**
     * Revoke a previously issued token.
     * Revoke token
     */
    tokenRevocation(requestParameters?: TokenRevocationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<void>;
}
