/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime.js';
import type { CreateSubscriberSuccessResponse, GetSubscriberResponse, GetSubscribersResponse } from '../models/index.js';
export interface CreateSubscriberRequest {
    firstName: string;
    lastName: string | null;
    email: string | null;
}
export interface GetSubscriberRequest {
    subscriberId: string;
}
export interface GetSubscribersRequest {
    sort?: GetSubscribersSortEnum;
    pageSize?: number | null;
    nextToken?: string | null;
}
/**
 *
 */
export declare class SubscribersApi extends runtime.BaseAPI {
    /**
     * Create subscriber.
     * Create Subscriber
     */
    createSubscriberRaw(requestParameters: CreateSubscriberRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<CreateSubscriberSuccessResponse>>;
    /**
     * Create subscriber.
     * Create Subscriber
     */
    createSubscriber(requestParameters: CreateSubscriberRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<CreateSubscriberSuccessResponse>;
    /**
     * Retrieve a subscriber record.
     * Get Subscriber
     */
    getSubscriberRaw(requestParameters: GetSubscriberRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<GetSubscriberResponse>>;
    /**
     * Retrieve a subscriber record.
     * Get Subscriber
     */
    getSubscriber(requestParameters: GetSubscriberRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<GetSubscriberResponse>;
    /**
     * The returned list can be sorted by full name or email address in ascending or descending order. The number of records to return at a time can also be controlled using the `page_size` query string parameter.
     * List Subscribers
     */
    getSubscribersRaw(requestParameters: GetSubscribersRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<GetSubscribersResponse>>;
    /**
     * The returned list can be sorted by full name or email address in ascending or descending order. The number of records to return at a time can also be controlled using the `page_size` query string parameter.
     * List Subscribers
     */
    getSubscribers(requestParameters?: GetSubscribersRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<GetSubscribersResponse>;
}
/**
 * @export
 */
export declare const GetSubscribersSortEnum: {
    readonly NameAsc: "name_asc";
    readonly NameDesc: "name_desc";
    readonly EmailAsc: "email_asc";
    readonly EmailDesc: "email_desc";
};
export type GetSubscribersSortEnum = typeof GetSubscribersSortEnum[keyof typeof GetSubscribersSortEnum];
