/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface CreateOrganizationRequest
 */
export interface CreateOrganizationRequest {
    /**
     * The organization's name.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    name: string;
    /**
     * The organization's feature flag settings.
     * @type {{ [key: string]: string; }}
     * @memberof CreateOrganizationRequest
     */
    featureFlags?: {
        [key: string]: string;
    };
    /**
     * The organization's ID.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    externalId?: string;
    /**
     * The organization's brand settings - background color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    backgroundColor?: string;
    /**
     * The organization's brand settings - button color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    buttonColor?: string;
    /**
     * The organization's brand settings - button text color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    buttonTextColor?: string;
    /**
     * The organization's brand settings - link color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    linkColor?: string;
    /**
     * The organization's brand settings - dark mode background color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    backgroundColorDark?: string;
    /**
     * The organization's brand settings - dark mode button color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    buttonColorDark?: string;
    /**
     * The organization's brand settings - dark mode button text color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    buttonTextColorDark?: string;
    /**
     * The organization's brand settings - dark mode link color.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    linkColorDark?: string;
    /**
     * The organization's brand settings - theme/mode 'light' | 'dark' | 'user_preference'.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    themeCode?: string;
    /**
     * The organization's handle.
     * @type {string}
     * @memberof CreateOrganizationRequest
     */
    handle?: string;
    /**
     * Users can sign up to this organization.
     * @type {boolean}
     * @memberof CreateOrganizationRequest
     */
    isAllowRegistrations?: boolean;
}
/**
 * @export
 */
export declare const CreateOrganizationRequestFeatureFlagsEnum: {
    readonly Str: "str";
    readonly Int: "int";
    readonly Bool: "bool";
};
export type CreateOrganizationRequestFeatureFlagsEnum = typeof CreateOrganizationRequestFeatureFlagsEnum[keyof typeof CreateOrganizationRequestFeatureFlagsEnum];
/**
 * Check if a given object implements the CreateOrganizationRequest interface.
 */
export declare function instanceOfCreateOrganizationRequest(value: object): boolean;
export declare function CreateOrganizationRequestFromJSON(json: any): CreateOrganizationRequest;
export declare function CreateOrganizationRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): CreateOrganizationRequest;
export declare function CreateOrganizationRequestToJSON(value?: CreateOrganizationRequest | null): any;
