/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface CreatePropertyRequest
 */
export interface CreatePropertyRequest {
    /**
     * The name of the property.
     * @type {string}
     * @memberof CreatePropertyRequest
     */
    name: string;
    /**
     * Description of the property purpose.
     * @type {string}
     * @memberof CreatePropertyRequest
     */
    description?: string;
    /**
     * The property identifier to use in code.
     * @type {string}
     * @memberof CreatePropertyRequest
     */
    key: string;
    /**
     * The property type.
     * @type {string}
     * @memberof CreatePropertyRequest
     */
    type: CreatePropertyRequestTypeEnum;
    /**
     * The context that the property applies to.
     * @type {string}
     * @memberof CreatePropertyRequest
     */
    context: CreatePropertyRequestContextEnum;
    /**
     * Whether the property can be included in id and access tokens.
     * @type {boolean}
     * @memberof CreatePropertyRequest
     */
    isPrivate: boolean;
    /**
     * Which category the property belongs to.
     * @type {string}
     * @memberof CreatePropertyRequest
     */
    categoryId: string;
}
/**
 * @export
 */
export declare const CreatePropertyRequestTypeEnum: {
    readonly SingleLineText: "single_line_text";
    readonly MultiLineText: "multi_line_text";
};
export type CreatePropertyRequestTypeEnum = typeof CreatePropertyRequestTypeEnum[keyof typeof CreatePropertyRequestTypeEnum];
/**
 * @export
 */
export declare const CreatePropertyRequestContextEnum: {
    readonly Org: "org";
    readonly Usr: "usr";
};
export type CreatePropertyRequestContextEnum = typeof CreatePropertyRequestContextEnum[keyof typeof CreatePropertyRequestContextEnum];
/**
 * Check if a given object implements the CreatePropertyRequest interface.
 */
export declare function instanceOfCreatePropertyRequest(value: object): boolean;
export declare function CreatePropertyRequestFromJSON(json: any): CreatePropertyRequest;
export declare function CreatePropertyRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): CreatePropertyRequest;
export declare function CreatePropertyRequestToJSON(value?: CreatePropertyRequest | null): any;
