/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface SetUserPasswordRequest
 */
export interface SetUserPasswordRequest {
    /**
     * The hashed password.
     * @type {string}
     * @memberof SetUserPasswordRequest
     */
    hashedPassword: string;
    /**
     * The hashing method or algorithm used to encrypt the user’s password. Default is bcrypt.
     * @type {string}
     * @memberof SetUserPasswordRequest
     */
    hashingMethod?: SetUserPasswordRequestHashingMethodEnum;
    /**
     * Extra characters added to passwords to make them stronger. Not required for bcrypt.
     * @type {string}
     * @memberof SetUserPasswordRequest
     */
    salt?: string;
    /**
     * Position of salt in password string. Not required for bcrypt.
     * @type {string}
     * @memberof SetUserPasswordRequest
     */
    saltPosition?: SetUserPasswordRequestSaltPositionEnum;
    /**
     * The user will be prompted to set a new password after entering this one.
     * @type {boolean}
     * @memberof SetUserPasswordRequest
     */
    isTemporaryPassword?: boolean;
}
/**
 * @export
 */
export declare const SetUserPasswordRequestHashingMethodEnum: {
    readonly Bcrypt: "bcrypt";
    readonly Crypt: "crypt";
    readonly Md5: "md5";
    readonly Wordpress: "wordpress";
};
export type SetUserPasswordRequestHashingMethodEnum = typeof SetUserPasswordRequestHashingMethodEnum[keyof typeof SetUserPasswordRequestHashingMethodEnum];
/**
 * @export
 */
export declare const SetUserPasswordRequestSaltPositionEnum: {
    readonly Prefix: "prefix";
    readonly Suffix: "suffix";
};
export type SetUserPasswordRequestSaltPositionEnum = typeof SetUserPasswordRequestSaltPositionEnum[keyof typeof SetUserPasswordRequestSaltPositionEnum];
/**
 * Check if a given object implements the SetUserPasswordRequest interface.
 */
export declare function instanceOfSetUserPasswordRequest(value: object): boolean;
export declare function SetUserPasswordRequestFromJSON(json: any): SetUserPasswordRequest;
export declare function SetUserPasswordRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SetUserPasswordRequest;
export declare function SetUserPasswordRequestToJSON(value?: SetUserPasswordRequest | null): any;
