/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { UserIdentitiesInner } from './UserIdentitiesInner.js';
/**
 *
 * @export
 * @interface UsersResponseUsersInner
 */
export interface UsersResponseUsersInner {
    /**
     * Unique id of the user in Kinde.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    id?: string;
    /**
     * External id for user.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    providedId?: string;
    /**
     * Default email address of the user in Kinde.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    email?: string;
    /**
     * Primary username of the user in Kinde.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    username?: string;
    /**
     * User's last name.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    lastName?: string;
    /**
     * User's first name.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    firstName?: string;
    /**
     * Whether the user is currently suspended or not.
     * @type {boolean}
     * @memberof UsersResponseUsersInner
     */
    isSuspended?: boolean;
    /**
     * User's profile picture URL.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    picture?: string;
    /**
     * Total number of user sign ins.
     * @type {number}
     * @memberof UsersResponseUsersInner
     */
    totalSignIns?: number | null;
    /**
     * Number of consecutive failed user sign ins.
     * @type {number}
     * @memberof UsersResponseUsersInner
     */
    failedSignIns?: number | null;
    /**
     * Last sign in date in ISO 8601 format.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    lastSignedIn?: string | null;
    /**
     * Date of user creation in ISO 8601 format.
     * @type {string}
     * @memberof UsersResponseUsersInner
     */
    createdOn?: string | null;
    /**
     * Array of organizations a user belongs to.
     * @type {Array<string>}
     * @memberof UsersResponseUsersInner
     */
    organizations?: Array<string>;
    /**
     * Array of identities belonging to the user.
     * @type {Array<UserIdentitiesInner>}
     * @memberof UsersResponseUsersInner
     */
    identities?: Array<UserIdentitiesInner>;
}
/**
 * Check if a given object implements the UsersResponseUsersInner interface.
 */
export declare function instanceOfUsersResponseUsersInner(value: object): boolean;
export declare function UsersResponseUsersInnerFromJSON(json: any): UsersResponseUsersInner;
export declare function UsersResponseUsersInnerFromJSONTyped(json: any, ignoreDiscriminator: boolean): UsersResponseUsersInner;
export declare function UsersResponseUsersInnerToJSON(value?: UsersResponseUsersInner | null): any;
