/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime.js';
import type { ConnectedAppsAccessToken, ConnectedAppsAuthUrl, SuccessResponse } from '../models/index.js';
export interface GetConnectedAppAuthUrlRequest {
    keyCodeRef: string;
    userId?: string;
    orgCode?: string;
    overrideCallbackUrl?: string;
}
export interface GetConnectedAppTokenRequest {
    sessionId: string;
}
export interface RevokeConnectedAppTokenRequest {
    sessionId: string;
}
/**
 *
 */
export declare class ConnectedAppsApi extends runtime.BaseAPI {
    /**
     * Get a URL that authenticates and authorizes a user to a third-party connected app.
     * Get Connected App URL
     */
    getConnectedAppAuthUrlRaw(requestParameters: GetConnectedAppAuthUrlRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<ConnectedAppsAuthUrl>>;
    /**
     * Get a URL that authenticates and authorizes a user to a third-party connected app.
     * Get Connected App URL
     */
    getConnectedAppAuthUrl(requestParameters: GetConnectedAppAuthUrlRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<ConnectedAppsAuthUrl>;
    /**
     * Get an access token that can be used to call the third-party provider linked to the connected app.
     * Get Connected App Token
     */
    getConnectedAppTokenRaw(requestParameters: GetConnectedAppTokenRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<ConnectedAppsAccessToken>>;
    /**
     * Get an access token that can be used to call the third-party provider linked to the connected app.
     * Get Connected App Token
     */
    getConnectedAppToken(requestParameters: GetConnectedAppTokenRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<ConnectedAppsAccessToken>;
    /**
     * Revoke the tokens linked to the connected app session.
     * Revoke Connected App Token
     */
    revokeConnectedAppTokenRaw(requestParameters: RevokeConnectedAppTokenRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<SuccessResponse>>;
    /**
     * Revoke the tokens linked to the connected app session.
     * Revoke Connected App Token
     */
    revokeConnectedAppToken(requestParameters: RevokeConnectedAppTokenRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<SuccessResponse>;
}
