/**
 * Kinde Management API
 * Provides endpoints to manage your Kinde Businesses
 *
 * The version of the OpenAPI document: 1
 * Contact: support@kinde.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime.js';
import type { CreatePermissionRequest, GetPermissionsResponse, SuccessResponse } from '../models/index.js';
export interface CreatePermissionOperationRequest {
    createPermissionRequest?: CreatePermissionRequest;
}
export interface DeletePermissionRequest {
    permissionId: string;
}
export interface GetPermissionsRequest {
    sort?: GetPermissionsSortEnum;
    pageSize?: number | null;
    nextToken?: string | null;
}
export interface UpdatePermissionsRequest {
    permissionId: number;
    createPermissionRequest?: CreatePermissionRequest;
}
/**
 *
 */
export declare class PermissionsApi extends runtime.BaseAPI {
    /**
     * Create a new permission.
     * Create Permission
     */
    createPermissionRaw(requestParameters: CreatePermissionOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<SuccessResponse>>;
    /**
     * Create a new permission.
     * Create Permission
     */
    createPermission(requestParameters?: CreatePermissionOperationRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<SuccessResponse>;
    /**
     * Delete permission
     * Delete Permission
     */
    deletePermissionRaw(requestParameters: DeletePermissionRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<SuccessResponse>>;
    /**
     * Delete permission
     * Delete Permission
     */
    deletePermission(requestParameters: DeletePermissionRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<SuccessResponse>;
    /**
     * The returned list can be sorted by permission name or permission ID in ascending or descending order. The number of records to return at a time can also be controlled using the `page_size` query string parameter.
     * List Permissions
     */
    getPermissionsRaw(requestParameters: GetPermissionsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<GetPermissionsResponse>>;
    /**
     * The returned list can be sorted by permission name or permission ID in ascending or descending order. The number of records to return at a time can also be controlled using the `page_size` query string parameter.
     * List Permissions
     */
    getPermissions(requestParameters?: GetPermissionsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<GetPermissionsResponse>;
    /**
     * Update permission
     * Update Permission
     */
    updatePermissionsRaw(requestParameters: UpdatePermissionsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<SuccessResponse>>;
    /**
     * Update permission
     * Update Permission
     */
    updatePermissions(requestParameters: UpdatePermissionsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<SuccessResponse>;
}
/**
 * @export
 */
export declare const GetPermissionsSortEnum: {
    readonly NameAsc: "name_asc";
    readonly NameDesc: "name_desc";
    readonly IdAsc: "id_asc";
    readonly IdDesc: "id_desc";
};
export type GetPermissionsSortEnum = typeof GetPermissionsSortEnum[keyof typeof GetPermissionsSortEnum];
