import type { BrowserPKCEClientOptions } from '../types.js';
export declare const createKindeBrowserClient: (options: BrowserPKCEClientOptions) => {
    getUserOrganizations: () => Promise<{
        orgCodes: string[];
    }>;
    handleRedirectToApp: (callbackURL: URL) => Promise<void>;
    isAuthenticated: () => Promise<boolean>;
    getOrganization: () => Promise<{
        orgCode: string | null;
    }>;
    getBooleanFlag: (code: string, defaultValue?: boolean) => Promise<boolean>;
    getIntegerFlag: (code: string, defaultValue?: number) => Promise<number>;
    getUserProfile: () => Promise<import("../../index.js").UserType>;
    getPermissions: () => Promise<{
        permissions: string[];
        orgCode: string | null;
    }>;
    getPermission: (name: string) => Promise<{
        orgCode: string | null;
        isGranted: boolean;
    }>;
    getClaimValue: (claim: string, type?: import("../../index.js").ClaimTokenType) => Promise<unknown | null>;
    getStringFlag: (code: string, defaultValue?: string) => Promise<string>;
    createOrg: (options?: import("../types.js").CreateOrgURLOptions) => Promise<URL>;
    getClaim: (claim: string, type?: import("../../index.js").ClaimTokenType) => Promise<{
        name: string;
        value: unknown | null;
    }>;
    getToken: () => Promise<string>;
    refreshTokens: () => Promise<import("../../index.js").OAuth2CodeExchangeResponse>;
    register: (options?: import("../types.js").RegisterURLOptions) => Promise<URL>;
    getUser: () => Promise<import("../../index.js").UserType>;
    getFlag: (code: string, defaultValue?: import("../../index.js").FlagType[keyof import("../../index.js").FlagType], type?: keyof import("../../index.js").FlagType) => Promise<import("../../index.js").GetFlagType>;
    logout: () => Promise<URL>;
    login: (options?: import("../types.js").LoginURLOptions) => Promise<URL>;
    portal: (options: import("@kinde/js-utils/dist/types.js").GeneratePortalUrlParams) => Promise<{
        url: URL;
    }>;
};
